#ifndef __DPFORM_H__
#define __DPFORM_H_

#include <glib.h>

typedef struct {
    gchar fileDescription[128];
    guint32 version;
    guint32 dwFlag;
    guint32 width;
    guint32 height;
    guint32 nBitmap;
    guint32 reserved1;
    guint32 reserved2;
    guint32 reserved3;
} DPIXED_FILEHEADER;

#define DPF_FILE_HASGLOBALCOLORTABLE    0x00000001
#define DPF_FILE_HASGRID                0x00000010
#define DPF_FILE_HASFRAME               0x00000020
#define DPF_FILE_HASSHAPE               0x00000040

typedef struct {
    guint32 dwSize;
    guint32 dwFlag;
    guint32 keyColor;
    guint32 alpha;
    guint32 maskBit;
    guint32 bgColor;
    guint32 imageSize;
    guint32 reserved;
    gchar description[64];
    // D-Pixed 2.10 added the following.
    gint32 left;
    gint32 top;
    gint32 right;
    gint32 bottom;
    gint32 delay;
    gint32 animeMode;
    gint32 animeInput;
    gint32 animeTransparent;
    // D-Pixed 2.11 added the following.
    // When DPF_IMAGE_COLORMASK is set, there are 256 byte data.
} DPIXED_FILEIMAGEHEADER;

#define DPF_IMAGE_HASMASK 			0x00000001
#define DPF_IMAGE_HASLOCALCOLORTABLE	        0x00000002
#define DPF_IMAGE_MASKCOMPRESSED 		0x00000010
#define DPF_IMAGE_IMAGECOMPRESSED 		0x00000020
#define DPF_IMAGE_ENABLE 			0x00010000
#define DPF_IMAGE_USEALPHAPLANE 		0x00020000
#define DPF_IMAGE_COLORMASK 			0x00100000

typedef struct {
    gchar fileDescription[128];
    guint32 version;
    guint32 dwFlag;
    guint32 size;
    guint32 reserved;
} DPIXED_FILEPALETTEHEADER;

typedef struct __DGR_HEADER_ {
    gchar m_Comment[128];
    guint32 m_Width;
    guint32 m_Height;
    guint32 m_XGrid;
    guint32 m_YGrid;
    guint32 m_Flags;
    guint32 m_Reserved;
} DPGRID_HEADER;

typedef struct {
    guchar rgbBlue;
    guchar rgbGreen;
    guchar rgbRed;
    guchar rgbReserved;
} DP_RGBQuad __attribute__((packed));

#endif                          /* __DPFORM_H__ */
